##
# EzPhoto. Main module.
# @author kaiba http://pokosho.com

use strict;
package EzPhoto;
use Log::Log4perl;
use util::Configure;
use util::SaveFileReader;
use request::RequestParser;
use request::Requester;
use CGI;

# For debug
use request::updater::Updater;
use request::updater::UpdateRequester;
use request::rss::RssRequester;

##
# Constructer
sub new() {
	my $this = shift;
	my $self = {};
	
	# load logger for debug
	Log::Log4perl::init('./log4perl.conf');
	my $logger = Log::Log4perl::get_logger("mylogger");
	$logger->info("this is INFO message");
	$logger->debug("this is DEBUG message");
	
	bless $self, $this;
	return $self;
}

##
# start process
sub run() {
	my $req;
	my $doUpdate = Const::FALSE;
	my $logger = Log::Log4perl->get_logger("mylogger");
	my ($mode, $index, $opt) = "";
	$logger->info("-------------------------------");
	$logger->info("start EzPhoto.");
	
	my $configure = Configure->getInstance();
	$configure->load("./Ezphoto.conf");
	$logger->debug("loaded");
	
	my $sfr = SaveFileReader->getInstance();
	my $sf = $configure->getParam('UP_DIR') ."/". $configure->getParam('SAVE_FILE');
	if($sfr->load($sf) == Const::OK) {
		$logger->debug("found save file.");
		# check update
		$doUpdate = $sfr->isToUpcate();
	} else {
		# not found save file. Call update to create new one. 
		$logger->error("not found save file. start update.");
		$doUpdate = Const::TRUE;
	}
	if ($doUpdate == Const::TRUE) {
		$logger->debug("start update.");
		$req = new Updater();
		$req->request();
		$req = new RssRequester();
		$req->request();
	}
	
	# get requester
	my $q = new CGI;
	$mode = $q->param('mode');
	$index = $q->param('index');
	# DEBUG: MODE ==================
	#$mode = "update";
	# ==============================
	$opt = $q->param('opt');
	if (!defined $mode){$mode = "";}
	if (!defined $index){$index = "";}
	if (!defined $opt){$opt = "";}
	$logger->info("mode : $mode");
	$logger->info("index : $index");
	$logger->info("opt : $opt");
	if ($index eq "") {
		$index = 0;
	}
	
	# TODO:remove debug code
	#my $req = new RssRequester();
	$req = RequestParser->getRequester($mode);
	$logger->info("call request...");
	$req->request($index, $opt);
	$logger->info("end EzPhoto.");
	$logger->info("-------------------------------");
}

1;

