

##
# RequestParser. Parse request and return Requester object.
# @author kaiba http://pokosho.com
package RequestParser;
use common::Const;
use request::printer::ErrorPrinter;
use YAML::Tiny;
use Data::Dumper;

# classes which extends Requester
# if you add new requester, never forget to it here.
use request::printer::PagePrinter;

## request. static method.
# @param mode String of mode
sub getRequester() {
	my $this = shift;
	my ($mode) = @_ ;
	my $logger = Log::Log4perl::get_logger("mylogger");
	my $requester;
	
	my $loaded;
	my $file = Const::REQUESTER_MAPPING;
	if (-e $file) {
		$logger->debug("found REQUESTER_MAPPING");
		$loaded = YAML::Tiny::LoadFile($file);
	} else {
		$logger->debug("not found REQUESTER_MAPPING");
		return new ErrorPrinter();
	}
	$logger->debug(Dumper($loaded));
	if ($mode eq "") {
		$mode = 'default';
	}
	$logger->debug("mode:class = $mode : $loaded->{$mode}");
	
	# create requester(extends Requester)
	$requester = ($loaded->{$mode})->new;
	
	return $requester;
}

1;

