##
# Writer.
# @author kaiba http://pokosho.com

package Writer;
use request::printer::Printer;
use base qw(Printer);
use strict;
use util::Configure;
use Data::Dumper;
use util::SaveFileReader;

##
# Constractor
sub new{
	my $this = shift;
	my $self = {
		# page index
		"index" => 0,
		# image index
		imageIndex => 0,
		# path to template file
		"template" => "",
		# output file
		"file" => "",
		# file handle
		"fileHandle" => undef
	};
	bless $self, $this;
	return $self;
}

## set output file path.
sub setFile() {
	my $this = shift;
	my ($file) = @_;
	$this->{file} = $file;
	my $logger = Log::Log4perl::get_logger("mylogger");
	$logger->debug("setFile:$file");
}

##
# set image index
# @param index index of image.
sub setImageIndex() {
	my $this = shift;
	my ($index) = @_;
	$this->{imageIndex} = $index;
}

##
# write page. 
sub print() {
	my $this = shift;
	my $html = $this->readTemplate();
	my $logger = Log::Log4perl::get_logger("mylogger");
	$html = $this->applyTemplate($html);
	$logger->debug("result:$html");
	my $fh = $this->{fileHandle};
	print $fh $html;
}


## open file
# @return 
sub open() {
	my $this = shift;
	my $logger = Log::Log4perl::get_logger("mylogger");
	$logger->debug("open");
	open(my $fh, ">$this->{file}") or die("can't open:$this->{file}");
	$this->{fileHandle} = $fh;
}

## close file
sub close() {
	my $this = shift;
	return close($this->{fileHandle});
}

##  print line
# @param line line to output
sub println() {
	my $this = shift;
	my ($line) = @_;
	my $fh = $this->{fileHandle};
	print $fh $line;
}



1;
