##
# PagePrinter. It's extends Requester.
# @author kaiba http://pokosho.com
package PagePrinter;
use request::Requester;
use base qw(Requester);

use common::Const;
use request::printer::Printer;
use request::printer::ImagePrinter;
use Data::Dumper;
use strict;

## Constracter
sub new() {
	my $this = shift;
	my $self = {
		index => 0,
		opt => ""
	};
	bless $self, $this;
	return $self;
}

## request
# @param inde index
# @param opt optional string
sub request() {
	my $this = shift;
	my ($index, $opt) = @_ ;
	my $logger = Log::Log4perl::get_logger("mylogger");
	$logger->debug("start PagePrinter. index:$index opt:$opt");
	if (!defined $index){$index = 0;}
	if (!defined $opt){$opt = "";}
	$this->{index} = $index;
	$this->{opt} = $opt;
	$this->printPage($index);
}

## printPage. Pricate method.
# @param index page index
sub printPage() {
	my $this = shift;
	my ($index) = @_ ;

	my $logger = Log::Log4perl::get_logger("mylogger");
	my $sfr = SaveFileReader->getInstance();
	my $configure = Configure->getInstance();
	my $tmpldir = $configure->getParam('TMPL_DIR');
	$logger->debug("start printPage.");
		
	# make HTML
	my $rc = open(TMPL, "$tmpldir/page.tmpl");
	if ($rc == 0) {
		$logger->error("$tmpldir/page.tmpl can't open.");
		#TODO: print error page.
		close(TMPL);
		return;
	}
	
	# start print page
	print "Content-type: text/html\n\n";
	my $line;	
	my $pr = new Printer();
	$pr->setIndex($index);
	my $ip = new ImagePrinter();
	$ip->setTemplate("$tmpldir/gallery.tmpl");
	$ip->setIndex($index);
	
	while ($line = <TMPL>) {
		if($line =~ /<HTML_HEAD>/) {
				# if the line contains <HTML_HEAD>, print html header.
				$logger->debug("found <HTML_HEAD>");
				$pr->setTemplate("$tmpldir/htmlhead.tmpl");
				$pr->print();
		} elsif($line =~ /<HTML_BODY>/) {
				# if the line contains <HTML_BODY>,
				# print header, gallary, pager, kakolog link, etc...
				$logger->debug("found <HTML_BODY>");
				$pr->setTemplate("$tmpldir/head.tmpl");
				$pr->print();
				
				# print images
				my $i;
				my $imgsref = $sfr->getImages();
				my @imgs = @$imgsref;
				my $start = $this->{index} * ($configure->getParam('PRINT_NUM'));

				# print imgaes.
				for ($i = $start;
						$i < $start + $configure->getParam('PRINT_NUM') && $i < @imgs;
						$i++) {
					$logger->debug("image index at PagePrinter:$i");
					$ip->setImageIndex($i);
					$ip->print();
				}
				$pr->setTemplate("$tmpldir/pagerlink.tmpl");
				$pr->print();
				$pr->setTemplate("$tmpldir/foot.tmpl");
				$pr->print();
				
				#print "<p>TEST Print for PagePrinter.</p>";
		} else {
				print $line;
		}
	}
	close(TMPL);
}

1;

