##
# RssRequester. Write RSS file..
# @author kaiba http://pokosho.com

package RssRequester;
use request::printer::Printer;
use base qw(Printer);
use strict;
use request::Writer;

##
# Constractor
sub new() {
	my $this = shift;
	my $self = {};
	bless $self, $this;
	return $self;
}


## request. Update and print result.
# @param index index
# @param opt optional string
sub request() {
	my $this = shift;
	my ($index, $opt) = @_ ;
	my $logger = Log::Log4perl::get_logger("mylogger");
	$logger->debug("start PagePrinter.");
	$this->{index} = $index;
	$this->{opt} = $opt;
	$this->writeRss();
}

## writeRss. Pricate method.
sub writeRss() {
	my $this = shift;

	my $logger = Log::Log4perl::get_logger("mylogger");
	my $sfr = SaveFileReader->getInstance();
	my $configure = Configure->getInstance();
	my $tmpldir = $configure->getParam('TMPL_DIR');
	$logger->debug("start writing RSS.");
		
	# make RSS
	my $rc = open(TMPL, "$tmpldir/rss.tmpl");
	if ($rc == 0) {
		$logger->error("$tmpldir/rss.tmpl can't open.");
		#TODO: print error page.
		close(TMPL);
		return;
	}
	
	# start print page
	my $line;	
	my $wr = new Writer();
	$wr->setFile($configure->getParam('RSS_FILE'));
	$wr->open();
	while ($line = <TMPL>) {
		if($line =~ /<RSS_FEED>/) {
				# if the line contains <HTML_HEAD>, print html header.
				$logger->debug("found <RSS_FEED>");
				$wr->setTemplate("$tmpldir/rss_feed.tmpl");
				$wr->print();
		} elsif($line =~ /<RSS_ITEM>/) {
				# if the line contains <HTML_BODY>,
				# print header, gallary, pager, kakolog link, etc...
				$logger->debug("found <RSS_ITEM>");
				$wr->setTemplate("$tmpldir/rss_item.tmpl");
				
				# print items
				my $i;
				my $imgsref = $sfr->getImages();
				my @imgs = @$imgsref;
				$wr->setTemplate("$tmpldir/rss_item.tmpl");
				for ($i = 0;
						$i < $configure->getParam('RSS_ITEM_NUM') && $i < @imgs;
						$i++) {
					$logger->debug("image index at RssWriter:$i");
					$wr->setImageIndex($i);
					$wr->print();
				}
		} else {
				$wr->println($line);
		}
	}
	$wr->close();
	close(TMPL);
}



1;
