##
# Configure. Singleton.
# @author kaiba http://pokosho.com

package Configure;
use strict;
use Log::Log4perl;
use YAML::Tiny;
use Data::Dumper;

# Only one Configure obj.
my $configure;

##
# get Configure obj.
sub getInstance{
	my $logger = Log::Log4perl::get_logger("mylogger");
	if(! $configure) {
		my $this = shift;
		my $hash = {params => undef};
		#$configure = bless {} => $class;
		bless $hash, $this;
		$configure = $hash;
		$logger->debug("create new configure.");
	}else{
		$logger->debug("return configure.");
	}
	return $configure;
}

##
# Load properties from configuration file.
# @param file File path of the configuration.
sub load {
	my $this = shift;
	my ($file) = @_ ;
	my $logger = Log::Log4perl::get_logger("mylogger");
	$logger->debug("CONF:$file");
	my ($loaded) = YAML::Tiny::LoadFile($file);
	$logger->debug(Dumper($loaded));
	$this->{params} = $loaded;
}

##
# Get a paramater.
# @param name name of paramater.
sub getParam {
	my $this = shift;
	my ($name) = @_ ;
	my $logger = Log::Log4perl::get_logger("mylogger");
	my $pm = $this->{params}->{$name};
	$logger->debug("$name = $pm");
	return $pm;
}

1;

